import unittest
from unittest.mock import patch

from tmc import points
from tmc.utils import load, load_module, reload_module, get_stdout, check_source
from functools import reduce
import os
import os.path
import textwrap
from random import choice, randint

exercise = 'src.hypotenuse'
function = "hypotenuse"

@points('1.Hypotenuse')
class hypotenuseTest(unittest.TestCase):
    @classmethod
    def setUpClass(cls):
        with patch('builtins.input', side_effect=[AssertionError("Att be om input från användaren förväntades inte")]):
           cls.module = load_module(exercise, 'en')

    def test_0a_main_program_ok(self):
        ok, line = check_source(self.module)
        message = """Koden för att testa funktionerna ska placeras inuti
if __name__ == "__main__":
block. Följande rad ska flyttas:
"""
        self.assertTrue(ok, message+line)

    def test1_function_exists(self):
        try:
            from src.hypotenuse import hypotenuse
        except:
            self.assertTrue(False, "Din kod bör innehålla funktion hypotenuse(leg1: float, leg2: float)")

    def test2_type_of_return_value(self):
        try:
            from src.hypotenuse import hypotenuse
            val = hypotenuse(1.0,1.0)
            taip = str(type(val)).replace("<class '","").replace("'>","")
            self.assertTrue(type(val) == float, f"Funktionen hypotenuse ska returnera en float, istället för {val} vilket är {taip}")
        except:
            self.assertTrue(False, f"Det uppstod ett fel när funktionen anropades med parametervärden (1.0, 1.0)")

    def test3_uses_import_expression(self):
        with open("src/hypotenuse.py") as f:
            cont = f.read()
            self.assertTrue("import" in cont and "math" in cont, f"Ditt program importerar inte sqrt-funktion från matematikmodulen med importuttryck.")
    

    def test4_test_with_values(self):
        test_cases = {(3.0, 4.0): 5.0, (5.0, 12.0): 13.0}
        for test_case in test_cases:
            with patch('builtins.input', side_effect=[AssertionError("Att be om input från användaren förväntades inte")]):
                reload_module(self.module)
                hypotenuse = load(exercise, function, 'en')

                val = hypotenuse(test_case[0], test_case[1])

                self.assertEqual(val, test_cases[test_case], f"Funktionen returnerade värdet {val} med parametervärdena {test_case}, det korrekta returvärdet skulle ha varit {test_cases[test_case]}")
              
if __name__ == '__main__':
    unittest.main()